(in-package :cffi-cairo)

(defcairoclass "pattern" pattern pattern-t
  (:constructors
   ("create_rgb" (:args (red :double) (green :double) (blue :double)))
   ("create_rgba"
    (:args (red :double) (green :double) (blue :double) (alpha :double)))
   ("create_for_surface" (:args (surface :pointer)))
   ("create_linear"
    (:args (x0 :double) (y0 :double) (x1 :double) (y1 :double)))
   ("create_radial"
    (:args (cx0 :double) (cy0 :double) (radius0 :double)
	   (cx1 :double) (cy1 :double) (radius1 :double)))
   )
  (:methods
   ("add_color_stop_rgb"
    (:args (offset :double) (red :double) (green :double) (blue :double)))
   ("add_color_stop_rgba"
    (:args (offset :double)
	   (red :double) (green :double) (blue :double) (alpha :double)))
   ("get_color_stop_count"
    (:return-type status-t)
    (:args (count :pointer))
    (:alternative (:orig-value status)
		  (:pointers (count :int))
		  (:body (values count* status))))
   ("get_color_stop_rgba"
    (:return-type status-t)
    (:args (index :int) (offset :pointer)
	   (red :pointer) (green :pointer) (blue :pointer) (alpha :pointer))
    (:alternative (:orig-value status)
		  (:args index)
		  (:pointers (offset :double)
			     (red :double) (green :double) (blue :double)
			     (alpha :double))
		  (:body (values (list red* green* blue* alpha*)
				 offset* status))))
   ("get_rgba"
   (:return-type status-t)
   (:args (red :pointer) (green :pointer) (blue :pointer) (alpha :pointer))
   (:alternative (:orig-value status)
		 (:pointers (red :double) (green :double) (blue :double)
			    (alpha :double))
		 (:body (values (list red* green* blue* alpha*) status))))
  ("get_surface"
   (:return-type status-t)
   (:args (surface :pointer))
   (:alternative (:orig-value status)
		 (:pointers (surface :pointer))
		 (:body (values surface* status))))
  ("get_linear_points"
   (:return-type status-t)
   (:args (x0 :pointer) (y0 :pointer) (x1 :pointer) (y1 :pointer))
   (:alternative (:orig-value status)
		 (:pointers (x0 :double) (y0 :double)
			    (x1 :double) (y1 :double))
		 (:body (values (list x0* y0* x1* y1*) status))))
  ("get_radial_circles"
   (:return-type status-t)
   (:args (cx0 :pointer) (cy0 :pointer) (r0 :pointer)
	  (cx1 :pointer) (cy1 :pointer) (r1 :pointer))
   (:alternative (:orig-value status)
		 (:pointers (cx0 :double) (cy0 :double) (r0 :double)
			    (cx1 :double) (cy1 :double) (r1 :double))
		 (:body (values (list (list cx0* cy0* r0* cx1* cy1* r1*)
				      status)))))
  ("reference" (:return-type :pointer))
  ("destroy")
  ("status" (:return-type status-t))
  ("set_extend" (:args (extend extend-t)))
  ("get_extend" (:return-type extend-t))
  ("set_filter" (:args (filter filter-t)))
  ("get_filter" (:return-type filter-t))
  ("set_matrix" (:args (matrix :pointer)))
  ("get_matrix" (:args (matrix :pointer)))
  ("get_type" (:return-type pattern-type-t))
  ("get_reference_count" (:return-type :uint))
  ("set_user_data"
   (:return-type status-t)
   (:args (key user-data-key-t) (user-data :pointer)
	  (destroy destroy-func-t)))
  ("get_user_data"
   (:return-type :pointer)
   (:args (key user-data-key-t)))))
