;;;
;;; Definitions of the data types used by cairo.
;;;

(in-package :cffi-cairo)

(defctype surface-t :pointer)

(defctype context-t :pointer)

(defctype pattern-t :pointer)

(defcenum status-t
  (:CAIRO-STATUS-SUCCESS 0)
  :CAIRO-STATUS-NO-MEMORY
  :CAIRO-STATUS-INVALID-RESTORE
  :CAIRO-STATUS-INVALID-POP-GROUP
  :CAIRO-STATUS-NO-CURRENT-POINT
  :CAIRO-STATUS-INVALID-MATRIX
  :CAIRO-STATUS-INVALID-STATUS
  :CAIRO-STATUS-NULL-POINTER
  :CAIRO-STATUS-INVALID-STRING
  :CAIRO-STATUS-INVALID-PATH-DATA
  :CAIRO-STATUS-READ-ERROR
  :CAIRO-STATUS-WRITE-ERROR
  :CAIRO-STATUS-SURFACE-FINISHED
  :CAIRO-STATUS-SURFACE-TYPE-MISMATCH
  :CAIRO-STATUS-PATTERN-TYPE-MISMATCH
  :CAIRO-STATUS-INVALID-CONTENT
  :CAIRO-STATUS-INVALID-FORMAT
  :CAIRO-STATUS-INVALID-VISUAL
  :CAIRO-STATUS-FILE-NOT-FOUND
  :CAIRO-STATUS-INVALID-DASH
  :CAIRO-STATUS-INVALID-DSC-COMMENT)

(defcenum content-t
  (:CAIRO-CONTENT-COLOR         #x1000)
  (:CAIRO-CONTENT-ALPHA         #x2000)
  (:CAIRO-CONTENT-COLOR-ALPHA   #x3000))

(defcenum antialias-t
  :CAIRO-ANTIALIAS-DEFAULT
  :CAIRO-ANTIALIAS-NONE
  :CAIRO-ANTIALIAS-GRAY
  :CAIRO-ANTIALIAS-SUBPIXEL)

(defcenum fill-rule-t
  :CAIRO-FILL-RULE-WINDING
  :CAIRO-FILL-RULE-EVEN-ODD)

(defcenum line-cap-t
  :CAIRO-LINE-CAP-BUTT
  :CAIRO-LINE-CAP-ROUND
  :CAIRO-LINE-CAP-SQUARE)

(defcenum line-join-t
  :CAIRO-LINE-JOIN-MITER
  :CAIRO-LINE-JOIN-ROUND
  :CAIRO-LINE-JOIN-BEVEL)

(defcenum operator-t
  :CAIRO-OPERATOR-CLEAR
  :CAIRO-OPERATOR-SOURCE
  :CAIRO-OPERATOR-OVER
  :CAIRO-OPERATOR-IN
  :CAIRO-OPERATOR-OUT
  :CAIRO-OPERATOR-ATOP
  :CAIRO-OPERATOR-DEST
  :CAIRO-OPERATOR-DEST-OVER
  :CAIRO-OPERATOR-DEST-IN
  :CAIRO-OPERATOR-DEST-OUT
  :CAIRO-OPERATOR-DEST-ATOP
  :CAIRO-OPERATOR-XOR
  :CAIRO-OPERATOR-ADD
  :CAIRO-OPERATOR-SATURATE)

(defcenum font-slant-t
  :CAIRO-FONT-SLANT-NORMAL
  :CAIRO-FONT-SLANT-ITALIC
  :CAIRO-FONT-SLANT-OBLIQUE)

(defcenum font-weight-t
  :CAIRO-FONT-WEIGHT-NORMAL
  :CAIRO-FONT-WEIGHT-BOLD)

(defcenum subpixel-order-t
  :CAIRO-SUBPIXEL-ORDER-DEFAULT
  :CAIRO-SUBPIXEL-ORDER-RGB
  :CAIRO-SUBPIXEL-ORDER-BGR
  :CAIRO-SUBPIXEL-ORDER-VRGB
  :CAIRO-SUBPIXEL-ORDER-VBGR)

(defcenum hint-style-t
  :CAIRO-HINT-STYLE-DEFAULT
  :CAIRO-HINT-STYLE-NONE
  :CAIRO-HINT-STYLE-SLIGHT
  :CAIRO-HINT-STYLE-MEDIUM
  :CAIRO-HINT-STYLE-FULL)

(defcenum hint-metrics-t
  :CAIRO-HINT-METRICS-DEFAULT
  :CAIRO-HINT-METRICS-OFF
  :CAIRO-HINT-METRICS-ON)

(defcenum font-type-t
  :CAIRO-FONT-TYPE-TOY
  :CAIRO-FONT-TYPE-FT
  :CAIRO-FONT-TYPE-WIN32
  :CAIRO-FONT-TYPE-ATSUI)

(defcenum path-data-type-t
  :CAIRO-PATH-MOVE-TO
  :CAIRO-PATH-LINE-TO
  :CAIRO-PATH-CURVE-TO
  :CAIRO-PATH-CLOSE-PATH)

(defcenum surface-type-t
  :CAIRO-SURFACE-TYPE-IMAGE
  :CAIRO-SURFACE-TYPE-PDF
  :CAIRO-SURFACE-TYPE-PS
  :CAIRO-SURFACE-TYPE-XLIB
  :CAIRO-SURFACE-TYPE-XCB
  :CAIRO-SURFACE-TYPE-GLITZ
  :CAIRO-SURFACE-TYPE-QUARTZ
  :CAIRO-SURFACE-TYPE-WIN32
  :CAIRO-SURFACE-TYPE-BEOS
  :CAIRO-SURFACE-TYPE-DIRECTFB
  :CAIRO-SURFACE-TYPE-SVG)

(defcenum format-t
  :CAIRO-FORMAT-ARGB32
  :CAIRO-FORMAT-RGB24
  :CAIRO-FORMAT-A8
  :CAIRO-FORMAT-A1
  :CAIRO-FORMAT-RGB16-565)

(defcenum content-t
  (:CAIRO-CONTENT-COLOR         #x1000)
  (:CAIRO-CONTENT-ALPHA         #x2000)
  (:CAIRO-CONTENT-COLOR-ALPHA   #x3000))

(defcenum antialias-t
  :CAIRO-ANTIALIAS-DEFAULT
  :CAIRO-ANTIALIAS-NONE
  :CAIRO-ANTIALIAS-GRAY
  :CAIRO-ANTIALIAS-SUBPIXEL)

(defcenum fill-rule-t
  :CAIRO-FILL-RULE-WINDING
  :CAIRO-FILL-RULE-EVEN-ODD)

(defcenum line-cap-t
  :CAIRO-LINE-CAP-BUTT
  :CAIRO-LINE-CAP-ROUND
  :CAIRO-LINE-CAP-SQUARE)

(defcenum line-join-t
  :CAIRO-LINE-JOIN-MITER
  :CAIRO-LINE-JOIN-ROUND
  :CAIRO-LINE-JOIN-BEVEL)

(defcenum operator-t
  :CAIRO-OPERATOR-CLEAR
  :CAIRO-OPERATOR-SOURCE
  :CAIRO-OPERATOR-OVER
  :CAIRO-OPERATOR-IN
  :CAIRO-OPERATOR-OUT
  :CAIRO-OPERATOR-ATOP
  :CAIRO-OPERATOR-DEST
  :CAIRO-OPERATOR-DEST-OVER
  :CAIRO-OPERATOR-DEST-IN
  :CAIRO-OPERATOR-DEST-OUT
  :CAIRO-OPERATOR-DEST-ATOP
  :CAIRO-OPERATOR-XOR
  :CAIRO-OPERATOR-ADD
  :CAIRO-OPERATOR-SATURATE)

(defcenum font-slant-t
  :CAIRO-FONT-SLANT-NORMAL
  :CAIRO-FONT-SLANT-ITALIC
  :CAIRO-FONT-SLANT-OBLIQUE)

(defcenum font-weight-t
  :CAIRO-FONT-WEIGHT-NORMAL
  :CAIRO-FONT-WEIGHT-BOLD)

(defcenum subpixel-order-t
  :CAIRO-SUBPIXEL-ORDER-DEFAULT
  :CAIRO-SUBPIXEL-ORDER-RGB
  :CAIRO-SUBPIXEL-ORDER-BGR
  :CAIRO-SUBPIXEL-ORDER-VRGB
  :CAIRO-SUBPIXEL-ORDER-VBGR)

(defcenum hint-style-t
  :CAIRO-HINT-STYLE-DEFAULT
  :CAIRO-HINT-STYLE-NONE
  :CAIRO-HINT-STYLE-SLIGHT
  :CAIRO-HINT-STYLE-MEDIUM
  :CAIRO-HINT-STYLE-FULL)

(defcenum hint-metrics-t
  :CAIRO-HINT-METRICS-DEFAULT
  :CAIRO-HINT-METRICS-OFF
  :CAIRO-HINT-METRICS-ON)

(defcenum font-type-t
  :CAIRO-FONT-TYPE-TOY
  :CAIRO-FONT-TYPE-FT
  :CAIRO-FONT-TYPE-WIN32
  :CAIRO-FONT-TYPE-ATSUI)

(defcenum path-data-type-t
  :CAIRO-PATH-MOVE-TO
  :CAIRO-PATH-LINE-TO
  :CAIRO-PATH-CURVE-TO
  :CAIRO-PATH-CLOSE-PATH)

(defcenum surface-type-t
  :CAIRO-SURFACE-TYPE-IMAGE
  :CAIRO-SURFACE-TYPE-PDF
  :CAIRO-SURFACE-TYPE-PS
  :CAIRO-SURFACE-TYPE-XLIB
  :CAIRO-SURFACE-TYPE-XCB
  :CAIRO-SURFACE-TYPE-GLITZ
  :CAIRO-SURFACE-TYPE-QUARTZ
  :CAIRO-SURFACE-TYPE-WIN32
  :CAIRO-SURFACE-TYPE-BEOS
  :CAIRO-SURFACE-TYPE-DIRECTFB
  :CAIRO-SURFACE-TYPE-SVG)

(defcenum format-t
  :CAIRO-FORMAT-ARGB32
  :CAIRO-FORMAT-RGB24
  :CAIRO-FORMAT-A8
  :CAIRO-FORMAT-A1
  :CAIRO-FORMAT-RGB16-565)

(defcenum pattern-type-t
  :CAIRO-PATTERN-TYPE-SOLID
  :CAIRO-PATTERN-TYPE-SURFACE
  :CAIRO-PATTERN-TYPE-LINEAR
  :CAIRO-PATTERN-TYPE-RADIAL)

(defcenum extend-t
  :CAIRO-EXTEND-NONE
  :CAIRO-EXTEND-REPEAT
  :CAIRO-EXTEND-REFLECT
  :CAIRO-EXTEND-PAD)

(defcenum filter-t
  :CAIRO-FILTER-FAST
  :CAIRO-FILTER-GOOD
  :CAIRO-FILTER-BEST
  :CAIRO-FILTER-NEAREST
  :CAIRO-FILTER-BILINEAR
  :CAIRO-FILTER-GAUSSIAN)

(defcstruct path-t
  (status status-t)
  (data :pointer)
  (num-data :int))

(defctype path-pt :pointer)

(defctype bool-t (:boolean :int))

(defcstruct path-header-t
  (type path-data-type-t)
  (length :int))

(defcstruct path-point-t
  (x :double)
  (y :double))

(defcunion path-data-t
  (header path-header-t)
  (point path-point-t))

(defcstruct rectangle-t
  (x :double)
  (y :double)
  (width :double)
  (height :double))

(defcstruct rectangle-list-t
  (status status-t)
  (rectangles rectangle-t)
  (num-rectangles :int))

(defctype rectangle-list-pt :pointer)

(defctype user-data-key-t :pointer)

(defctype destroy-func-t :pointer)

(defctype font-face-t :pointer)

(defctype scaled-font-t :pointer)

(defctype write-func-t :pointer)

(defcstruct matrix-t
  (xx :double)
  (yx :double)
  (xy :double)
  (yy :double)
  (x0 :double)
  (y0 :double))

(defctype matrix-pt :pointer)

(defctype font-options-t :pointer)

(defcstruct font-extents-t
  (ascent :double)
  (descent :double)
  (height :double)
  (max_x_advance :double)
  (max_y_advance :double))

(defcstruct text-extents-t
  (x_bearing :double)
  (y_bearing :double)
  (width :double)
  (height :double)
  (x_advance :double)
  (y_advance :double))

(defcstruct glyph-t
  (index :ulong)
  (x :double)
  (y :double))

(defctype glyph-pt :pointer)

(defcenum svg-version-t
  :SVG-VERSION-1-1
  :SVG-VERSION-1-2)

(defctype display-pt :pointer)


(defctype hdc-t :pointer)