(defpackage :cffi-cairo-snippets
  (:use :common-lisp :cffi-cairo)
  (:export run-snippet-png))

(in-package :cffi-cairo-snippets)

(defparameter *snippets* nil)

(defun snippet-normalize (cr width height)
  (scale cr width height)
  (set-line-width cr 0.04d0))

(defmacro defsnippet (name &body body)
  `(push (cons ,name (lambda (cr width height) ,@body)) *snippets*))

(defun run-snippet-png (snippets &optional (width 500d0) (height 500d0))
  (dolist (snippet snippets)
    (let ((fun (cdr (assoc snippet *snippets*))))
      (if (null fun)
	  (format t "Snippet ~a does not exist" snippet)
	  (let* ((surface (image-surface-create :cairo-format-argb32
						(floor width) (floor height)))
		 (cr (create surface)))
	    (funcall fun cr width height)
	    (surface-write-to-png surface
				  (concatenate 'string
					       (symbol-name snippet) ".PNG"))
	    (destroy cr)
	    (surface-destroy surface))))))